summaryrefslogtreecommitdiff
path: root/tests/rm/no-give-up
diff options
context:
space:
mode:
Diffstat (limited to 'tests/rm/no-give-up')
-rwxr-xr-xtests/rm/no-give-up58
1 files changed, 58 insertions, 0 deletions
diff --git a/tests/rm/no-give-up b/tests/rm/no-give-up
new file mode 100755
index 0000000..b85132b
--- /dev/null
+++ b/tests/rm/no-give-up
@@ -0,0 +1,58 @@
+#!/bin/sh
+# With rm from coreutils-5.2.1 and earlier, `rm -r' would mistakenly
+# give up too early under some conditions.
+
+# Copyright (C) 2004, 2006 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ rm --version
+fi
+
+PRIV_CHECK_ARG=require-root . $srcdir/../priv-check
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd "$pwd" && chmod -R u+rwx $t0 && rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+mkdir d
+touch d/f
+chown -R $NON_ROOT_USERNAME d
+chmod u=rwx .
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+# This must fail, since `.' is not writable by $NON_ROOT_USERNAME.
+setuidgid $NON_ROOT_USERNAME env PATH="$PATH" rm -rf d 2>/dev/null && fail=1
+
+# d must remain.
+test -d d || fail=1
+
+# f must have been removed.
+test -f d/f && fail=1
+
+(exit $fail); exit $fail